#include <sourcemod>
#include <sdktools>
#include <clientprefs>

#pragma semicolon 1

#define SOUND_NAME_SIZE 64
#define MUSICMANAGER_VERSION "1.0"
//#define PLUGIN_DEBUG

// convars
new Handle:g_PluginVersion = INVALID_HANDLE;
new Handle:g_enableplugin = INVALID_HANDLE;
new Handle:g_joincount = INVALID_HANDLE;
new Handle:g_randomsound = INVALID_HANDLE;

// manager
new lastSound;
//new maxSound;
new Handle:hSounds = INVALID_HANDLE;
new bool:playSound[MAXPLAYERS+1]; // settings
new bool:soundenabled = true;
new bool:followlist = true;

// cookies for save settings
new Handle:g_hMyCookie;

public Plugin:myinfo =
{
	name = "Neatek MusicManager [CS:GO]",
	author = "www.neatek.ru",
	description = "",
	version = SOURCEMOD_VERSION,
	url = "http://www.neatek.ru/"
};

public OnClientPostAdminCheck(client)
{
	if(!client 
	|| !IsClientInGame(client)
	|| IsFakeClient(client)
	) return;

	if(AreClientCookiesCached(client))
	{
		decl String:sCookieValue[11];
		GetClientCookie(client, g_hMyCookie, sCookieValue, sizeof(sCookieValue));
		playSound[client] = IntToBool(StringToInt(sCookieValue));
		//LogMessage("client #%d have #%d music settings",client, StringToInt(sCookieValue));
	}
}

EmitToClient(x, char[] sound) {
	ClientCommand(x, "play *%s",sound);
}

EmitToAll(char[] sound) {
	for(new x=1;x<=MaxClients;x++)
	{
		if(ClientValid(x)) 
		{
			ClientCommand(x, "play *%s",sound);
		}
	}
}

public toggleSound(client)
{
	if(playSound[client])
	{
		PrintToChat(client,"[MusicManager] Round End sounds enabled! (Settings saved)");
		playSound[client]=false;
	}
	else
	{
		PrintToChat(client,"[MusicManager] Round End sounds disabled! (Settings saved)");
		playSound[client]=true;
	}

	new newvalue = BoolToInt(playSound[client]);
	decl String:sCookieValue[11];
	IntToString(newvalue, sCookieValue, sizeof(sCookieValue));
	SetClientCookie(client, g_hMyCookie, sCookieValue);
	//LogMessage("client #d have #%b music settings",client, playSound[client]);
}

public Action:Command_Listener(client, const String:command[], argc)
{
	if(!client 
	|| !IsClientInGame(client)
	) return;

	decl String:word[24];
	GetCmdArgString(word, sizeof(word));
	StripQuotes(word);

	if(word[0] == '!' && word[1] == 'r') // optimize
		if(StrEqual(word, "!rsound")) toggleSound(client);
}

public Event_JoinSound(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));

	if(!client 
	|| !IsClientInGame(client)
	|| IsFakeClient(client)
	|| !pEnabled()
	) return;
	
	if(GetArraySize(hSounds) > 0)
	{
		new String:buffer[SOUND_NAME_SIZE];
		GetArrayString(hSounds, GetRandomInt(0, (rMaxjoin()-1)), buffer, SOUND_NAME_SIZE);
		//EmitSoundToClient(client,buffer,_,10);
		//ClientCommand(client, "playgamesound %s",buffer);
		//EmitSoundToClient(client,buffer);
		EmitToClient(client, buffer);

		#if defined PLUGIN_DEBUG
			PrintToServer("::Debug:: Play join sound: %s", buffer);
			LogMessage("::Debug:: Play join sound: %s", buffer);
		#endif
	}
}

public Action:Disable_sounds(args)
{
	new String:arg[128];
	GetCmdArg(0, arg, sizeof(arg));
	#if defined PLUGIN_DEBUG 
		LogMessage("sm_musicmanager_disable %d",arg);
	#endif
	if(strcmp(arg,"1") == 0) soundenabled = false;
	else soundenabled = true;
	
	#if defined PLUGIN_DEBUG
		PrintToServer("::Debug:: command disable sounds: %s", arg);
		LogMessage("::Debug:: command disable sounds: %s", arg);
	#endif
	return Plugin_Handled;
}

public OnPluginStart()
{
	g_PluginVersion 	= CreateConVar("sm_musicmanager_version", MUSICMANAGER_VERSION, "Version of GameVoting plugin", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	g_joincount			= CreateConVar("sm_musicmanager_joincount", "2", "Count of join sounds (join sounds take from playlist)");
	g_enableplugin 		= CreateConVar("sm_musicmanager_enable", "1", "Enable or disable plugin.");
	g_randomsound 		= CreateConVar("sm_musicmanager_random", "0", "Use random playlist (1) or following list(0)");
	AutoExecConfig(true, "MusicManager");
	HookConVarChange(g_PluginVersion, UpdateConVarVersion);
	RegServerCmd("sm_musicmanager_disable", Disable_sounds);
	AddCommandListener(Command_Listener, "say");
	AddCommandListener(Command_Listener, "say2");
	AddCommandListener(Command_Listener, "say_team");
	g_hMyCookie = RegClientCookie("musicmanager_enable", "", CookieAccess_Protected);
	
	HookEvent("round_end", Event_RoundEnd, EventHookMode_PostNoCopy);
	HookEvent("player_activate", Event_JoinSound);
	// load sounds
	hSounds = CreateArray(SOUND_NAME_SIZE);
	mmanager_loadsounds();
}

public Event_RoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	//ClientCommand(i, "playgamesound %s",buffer);
	if(!soundenabled) return;
	new jc = rMaxjoin();
	new arrays = GetArraySize(hSounds)-1;
	if(arrays > jc)
	{
		new String:buffer[SOUND_NAME_SIZE];
		if(followlist) GetArrayString(hSounds, lastSound, buffer, SOUND_NAME_SIZE);
		else GetArrayString(hSounds, GetRandomInt(lastSound, arrays), buffer, SOUND_NAME_SIZE);
		
		for(new i=1;i<=MaxClients;i++) 
			if(!playSound[i] && IsClientInGame(i)) 
				//EmitSoundToClient(i,buffer);
				EmitToClient(i, buffer);
		
		if(followlist) {
			lastSound++; 
			if(lastSound > arrays) lastSound = jc; 
		}
		
		#if defined PLUGIN_DEBUG
			PrintToServer("::Debug:: Emit sound to all: %s, type:%b, lastSound:%d", buffer,followlist,lastSound);
			LogMessage("::Debug:: Emit sound to all: %s, type:%b, lastSound:%d", buffer,followlist,lastSound);
		#endif
	} 
	else 
		LogError("Have not music to play!");
}

public mmanager_loadsounds()
{
	ClearArray(hSounds);
	new String:buffer[SOUND_NAME_SIZE], String:g_ListPath[PLATFORM_MAX_PATH];
	BuildPath(Path_SM,g_ListPath,sizeof(g_ListPath),"configs/musicmanager.txt");

	new Handle:hFile = OpenFile(g_ListPath,"r");

	if(hFile == INVALID_HANDLE) SetFailState("I can't open file addons/sourcemod/configs/musicmanager.txt");
	while(!IsEndOfFile(hFile))
	{
		if(!ReadFileLine(hFile,buffer,SOUND_NAME_SIZE)) {
			LogError("Can't read file configs/musicmanager.txt line [%s]",buffer);
			continue;
		}
		TrimString(buffer);
		if(strlen(buffer) > 5) 
		{
			PrecacheSound(buffer, true);
			PushArrayString(hSounds, buffer);
			Format(buffer,sizeof(buffer),"sound/%s",buffer);
			AddFileToDownloadsTable(buffer);
			#if defined PLUGIN_DEBUG
				PrintToServer("::Debug:: Sound loaded: %s", buffer);
				LogMessage("::Debug:: Sound loaded: %s", buffer);
			#endif
			//maxSound++;
		} 
		#if defined PLUGIN_DEBUG
		else {
			PrintToServer("::Debug:: strlen(buffer) < 5: %s", buffer);
			LogMessage("::Debug:: strlen(buffer) < 5: %s", buffer);
		}
		#endif
	}
	
	//maxSound-1;
}

public rMaxjoin()
{
	return GetConVarInt(g_joincount);
}

public bool:pEnabled()
{
	if(GetConVarInt(g_enableplugin) > 0) return true;
	return false;
}

public bool:IntToBool(integ)
{
	if(integ > 0) return true;
	return false;
}

public BoolToInt(boolean) 
{
	if(boolean) return 1;
	else return 0;
}

public OnMapStart() 
{
	CheckConvars();
	mmanager_loadsounds();
}

public UpdateConVarVersion(Handle:convar, const String:oldValue[], const String:newValue[])
{
	CheckConvars();
}

public OnConfigsExecuted()
{
	CheckConvars();
}

public CheckConvars()
{
	if(GetConVarInt(g_enableplugin) > 0) soundenabled = true; else soundenabled = false;
	if(GetConVarInt(g_randomsound) > 0) followlist = false; else followlist = true;
	lastSound = GetConVarInt(g_joincount);
	SetConVarString(g_PluginVersion, MUSICMANAGER_VERSION, true, true);
}
